searchData={"items":[{"type":"module","title":"ExGoogleSTT.Grpc.Connection","doc":"Main module of the library. It provides a high-level API for Google Cloud Speech-to-Text API.","ref":"ExGoogleSTT.Grpc.Connection.html"},{"type":"function","title":"ExGoogleSTT.Grpc.Connection.connect/0","doc":"Connects to a Google Cloud Speech-to-Text API","ref":"ExGoogleSTT.Grpc.Connection.html#connect/0"},{"type":"function","title":"ExGoogleSTT.Grpc.Connection.disconnect/1","doc":"Disconnects from Google Cloud Speech-to-Text API","ref":"ExGoogleSTT.Grpc.Connection.html#disconnect/1"},{"type":"function","title":"ExGoogleSTT.Grpc.Connection.request_opts/0","doc":"Returns a list of options that need to be passed to a Service Stub when making a gRPC call","ref":"ExGoogleSTT.Grpc.Connection.html#request_opts/0"},{"type":"module","title":"ExGoogleSTT.TranscriptionServer","doc":"A Server to handle transcription requests.","ref":"ExGoogleSTT.TranscriptionServer.html"},{"type":"function","title":"ExGoogleSTT.TranscriptionServer.cancel_stream/1","doc":"","ref":"ExGoogleSTT.TranscriptionServer.html#cancel_stream/1"},{"type":"function","title":"ExGoogleSTT.TranscriptionServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExGoogleSTT.TranscriptionServer.html#child_spec/1"},{"type":"function","title":"ExGoogleSTT.TranscriptionServer.chunk_every/2","doc":"","ref":"ExGoogleSTT.TranscriptionServer.html#chunk_every/2"},{"type":"function","title":"ExGoogleSTT.TranscriptionServer.chunk_every_rem/2","doc":"","ref":"ExGoogleSTT.TranscriptionServer.html#chunk_every_rem/2"},{"type":"function","title":"ExGoogleSTT.TranscriptionServer.end_stream/1","doc":"","ref":"ExGoogleSTT.TranscriptionServer.html#end_stream/1"},{"type":"function","title":"ExGoogleSTT.TranscriptionServer.process_audio/2","doc":"That's the main entrypoint for processing audio.\nIt will start a stream, if it's not already started and send the audio to it.\nIt will also send the config if it's not already sent.","ref":"ExGoogleSTT.TranscriptionServer.html#process_audio/2"},{"type":"function","title":"ExGoogleSTT.TranscriptionServer.start_link/1","doc":"Starts a transcription server.\nThe basic usage is to start the server with the config you want. It is then kept in state and can be used to send audio requests later on.","ref":"ExGoogleSTT.TranscriptionServer.html#start_link/1"},{"type":"function","title":"Examples - ExGoogleSTT.TranscriptionServer.start_link/1","doc":"iex> TranscriptionServer.start_link()\n    {:ok, #PID<0.123.0>}","ref":"ExGoogleSTT.TranscriptionServer.html#start_link/1-examples"},{"type":"function","title":"Options - ExGoogleSTT.TranscriptionServer.start_link/1","doc":"These options are all optional. The recognizer should be the main point of configuration.\n\n\n  - target - a pid to send the results to, defaults to self()\n  - language_codes - a list of language codes to use for recognition, defaults to [\"en-US\"]\n  - enable_automatic_punctuation - a boolean to enable automatic punctuation, defaults to true\n  - interim_results - a boolean to enable interim results, defaults to false\n  - recognizer - a string representing the recognizer to use, defaults to use the recognizer from the config\n  - model - a string representing the model to use, defaults to \"latest_long\". Be careful, changing to 'short' may have unintended consequences\n  - split_by_chunk - boolean - whether to split the audio into chunks or not, defaults to true. Used to avoid hitting the Google STT limit","ref":"ExGoogleSTT.TranscriptionServer.html#start_link/1-options"},{"type":"extras","title":"Google Cloud Speech gRPC API client","doc":"# Google Cloud Speech gRPC API client\n\n[![Hex.pm](https://img.shields.io/hexpm/v/ex_google_stt.svg)](https://hex.pm/packages/ex_google_stt)\n\nElixir client for Google Speech-to-Text V2 streaming API using gRPC","ref":"readme.html"},{"type":"extras","title":"Installation - Google Cloud Speech gRPC API client","doc":"The package can be installed by adding `:ex_google_stt` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_google_stt, \"~> 0.5.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Google Cloud Speech gRPC API client","doc":"This library uses [`Goth`](https://github.com/peburrows/goth) to obtain authentication tokens. It requires Google Cloud credendials to be configured. See [Goth's README](https://github.com/peburrows/goth#installation) for details.\n\nUsing Google's V2 API requires that you set a recognizer to use for your requests (see [here](https://cloud.google.com/speech-to-text/v2/docs/reference/rest/v2/projects.locations.recognizers#Recognizer])). It is a string like the following:\n\n`projects/{project}/locations/{location}/recognizers/{recognizer}`\n\nYou can either set this in the config or send it as a configuration when starting the `TranscriptionServer`.\n\nIn the config:\n```elixir\nconfig :ex_google_stt, recognizer: \"projects/{project}/locations/{location}/recognizers/_\"\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - Google Cloud Speech gRPC API client","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Introduction - Google Cloud Speech gRPC API client","doc":"The library is designed to abstract most of the GRPC logic, so I'll provide the most basic use of it here.\n\n- In summary, we use a `TranscriptionServer` than handles the GRPC streams to Google.\n- That `TranscriptionServer` is responsible for monitoring/opening the streams and to parse the responses.\n- Send audio data (as binary) using `TranscriptionServer.process_audio(server_pid, audio_data)`\n- The `TranscriptionServer` will then send the responses to the target pid, set when creating the server.\n- The caller should define a `handle_info` that will receive the transcripts and handle eventual errors.","ref":"readme.html#introduction"},{"type":"extras","title":"Initial Configurations - Google Cloud Speech gRPC API client","doc":"When starting the `TranscriptionServer`, you can define a few configs:\n\n```\n- target - a pid to send the results to, defaults to self()\n- language_codes - a list of language codes to use for recognition, defaults to [\"en-US\"]\n- enable_automatic_punctuation - a boolean to enable automatic punctuation, defaults to true\n- interim_results - a boolean to enable interim results, defaults to false\n- recognizer - a string representing the recognizer to use, defaults to use the recognizer from the config\n- model - a string representing the model to use, defaults to \"latest_long\". Be careful, changing to 'short' may have unintended consequences\n- explicit_decoding_config - a struct with audio decoding parameters\n```\n\nNote that apart from the `interim_results` these configurations are better off set-up in the reconizer directly, so that you can control it without deploying any code.\n\nSee here for details: https://cloud.google.com/speech-to-text/v2/docs/recognizers\n\nBasically, create a recognizer in GCP then add a system_env with the recognizer string on it.","ref":"readme.html#initial-configurations"},{"type":"extras","title":"Example - Google Cloud Speech gRPC API client","doc":"```elixir\n\ndefmodule MyModule.Transcribing do\n  use GenServer\n\n  alias ExGoogleSTT.{Error, SpeechEvent, Transcript, TranscriptionServer}\n\n  ...\n  def init(_opts) do\n    {:ok, transcription_server} = TranscriptionServer.start_link(target: self(), interim_results: true)\n  end\n\n  def handle_info({:got_new_speech, speech_binary}, state) do\n    TranscriptionServer.process_audio(state.server_pid, speech_binary)\n  end\n\n  def handle_info({:stt_event, %{Transcript{} = transcript}}, state) do\n    # Do whatever you need with the transcription\n  end\n\n  def handle_info({:stt_event, %SpeechEvent{event: :SPEECH_ACTIVITY_BEGIN}}, state) do\n    # You probably want to ignore these\n  end\n\n  def handle_info({:stt_event, :stream_timeout}, state) do\n    # You probably want to ignore these as well. This is only a simple GRPC timeout, when nothing is coming.\n  end\n\n  def handle_info({:response, %Error{status: some_status, message: message}}, state) do\n    # You might want to to log these, as they are real errors.\n  end\nend\n\n```","ref":"readme.html#example"},{"type":"extras","title":"Other usages - Google Cloud Speech gRPC API client","doc":"The library allows you define other response handling functions and even ditch the `GenServer` part of `TranscriptionServer` altogether.","ref":"readme.html#other-usages"},{"type":"extras","title":"Notes - Google Cloud Speech gRPC API client","doc":"","ref":"readme.html#notes"},{"type":"extras","title":"Decoding - Google Cloud Speech gRPC API client","doc":"If you are not relying on auto decoding, you can specify the custom encoding\nparameters of your audio stream.\n\n```elixir\ndefmodule MyModule.Transcribing do\n  use GenServer\n\n  alias ExGoogleSTT.TranscriptionServer\n  alias Google.Cloud.Speech.V2.ExplicitDecodingConfig\n\n  def init(_opts) do\n    {:ok, transcription_server} =\n      TranscriptionServer.start_link(\n        target: self(),\n        interim_results: true,\n        explicit_decoding_config: %ExplicitDecodingConfig{\n          encoding: :LINEAR16,\n          sample_rate_hertz: 16000,\n          audio_channel_count: 1\n        }\n      )\n  end\n```","ref":"readme.html#decoding"},{"type":"extras","title":"Infinite stream - Google Cloud Speech gRPC API client","doc":"Google's STT V2 knows when a sentence finishes, as long as there's some silence after it. When that happens, it'll return the transcription without ending the stream.\n\nTherefore, as long as we keep the stream open, we can keep transcribing realtime speech.\n\nA few points to notice though.\n- The `model` must be `long` or `latest_long`. `short` will result in ending the stream after the first utterance.\n- One must end the stream to ensure the transcription stops.","ref":"readme.html#infinite-stream"},{"type":"extras","title":"Auto-generated modules - Google Cloud Speech gRPC API client","doc":"This library uses [`protobuf-elixir`](https://github.com/tony612/protobuf-elixir) and its `protoc-gen-elixir` plugin to generate Elixir modules from `*.proto` files for Google's Speech gRPC API. The documentation for the types defined in `*.proto` files can be found [here](https://cloud.google.com/speech-to-text/docs/reference/rpc/google.cloud.speech.v1)","ref":"readme.html#auto-generated-modules"},{"type":"extras","title":"Tests - Google Cloud Speech gRPC API client","doc":"ALL the tests require communication with google, so you must have a google credentials configured to run them in this repo.\n\nTests with tag `:load_test` are excluded by default, since they can be a bit expensive to run, use `mix test --include load_test` to run them.\n\n#### Fixture\n\nA recording fragment in `test/fixtures` comes from an audiobook\n\"The adventures of Sherlock Holmes (version 2)\" available on [LibriVox](https://librivox.org/the-adventures-of-sherlock-holmes-by-sir-arthur-conan-doyle/)","ref":"readme.html#tests"},{"type":"extras","title":"Status - Google Cloud Speech gRPC API client","doc":"Current version of library supports only Streaming API and not tested in production. Treat this as experimental.","ref":"readme.html#status"},{"type":"extras","title":"License - Google Cloud Speech gRPC API client","doc":"Portions of this project are modifications based on work created by [Sofware Mansion](https://swmansion.com/) and used according to terms described in the Apache License 2.0. See [here](https://github.com/software-mansion-labs/elixir-gcloud-speech-grpc) for the original repository.\n\nThe work it is not endorsed by or affiliated with the original authors or their organizations.\n\nThe modifications are also licensed under Apache License 2.0.","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,49]}}